"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWatermark = void 0;
const typescript_1 = require("typescript");
/**
 * Generate a JSDoc comment with the generated watermark and `info.version`
 *
 * @param info OpenAPI info object
 * @returns ts.node with the watermark
 */
const createWatermark = (info) => typescript_1.factory.createJSDocComment("Generated by @openapi-codegen\n", [
    typescript_1.factory.createJSDocPropertyTag(typescript_1.factory.createIdentifier("version"), typescript_1.factory.createIdentifier(info.version), false),
]);
exports.createWatermark = createWatermark;
//# sourceMappingURL=createWatermark.js.map